/**
 *  Dies ist die Hauptklasse der Anwendung "Die Welt von Zuul".
 *  "Die Welt von Zuul" ist ein sehr einfaches, textbasiertes
 *  Adventure-Game. Ein Spieler kann sich in einer Umgebung bewegen,
 *  mehr nicht. Das Spiel sollte auf jeden Fall ausgebaut werden,
 *  damit es interessanter wird!
 * 
 *  Zum Spielen muss eine Instanz dieser Klasse erzeugt werden und
 *  an ihr die Methode "spielen" aufgerufen werden.
 * 
 *  Diese Instanz dieser Klasse erzeugt und initialisiert alle
 *  anderen Objekte der Anwendung: Sie legt alle Rume und einen
 *  Parser an und startet das Spiel. Sie wertet auch die Befehle
 *  aus, die der Parser liefert und sorgt fr ihre Ausfhrung.
 * 
 * @author  Michael Kolling and David J. Barnes
 * @version 1.0 (March 2003)
 */

class Spiel 
{
    private Parser parser;
    private Raum aktuellerRaum;
    private boolean schluesselAufgehoben = false;
    private boolean fackelnAufgehoben = false;
    private boolean schatzGehoben = false;
    Raum raum1,raum2,raum3,raum4,raum5,raum6,raum7,raum8,raum9,raum10,raum11,raum12,raum13,raum14,raum15,raum16;
    
    /**
     * Erzeuge ein Spiel und initialisiere die interne Raumkarte.
     */
    public Spiel() 
    {
        raeumeAnlegen();
        parser = new Parser();
    }

    /**
     * Erzeuge alle Rume und verbinde ihre Ausgnge miteinander.
     */
    private void raeumeAnlegen()
    {
        
      
        // die Rume erzeugen
        raum1 = new Raum("Sie befinden sich in einem Gang, in dem ein Spiegel an der Wand hngt.","raum1");
        raum2 = new Raum("Sie befinden sich in einem Gang, der von Algen berwuchert ist.","raum2");
        raum3 = new Raum("Sie befinden sich in einer Sackgasse mit Magnesiumfackeln.Vielleicht knnen Sie sie gebrauchen.","raum3");
        raum4 = new Raum("Sie befinden sich in einem Gang, in dem widerliche Tierchen hausen","raum4");
        raum5 = new Raum("Sie befinden sich in einem Gang, in dem Wassernymphen schwimmen.","raum5");
        raum6 = new Raum("Sie befinden sich in einem Gang, in dem Wasserleichen treiben.","raum6");
        raum7 = new Raum("Sie befinden sich in einer Sackgasse mit lockeren Felsbrocken","raum7");
        raum8 = new Raum("Sie befinden sich in einem Gang, der durch ein Gitter versperrt ist","raum8");
        raum9 = new Raum("Sie befinden sich in einer dunklen Hhle.Um sich zurecht zu finden, bentigen sie eine Lichtquelle.","raum9");
        raum10 = new Raum("Sie befinden sich in einem Sog. Sie werden langsam davon gezogen und sie knnen nichts dagegen tun! Sie erkennen vor sich einen Schredder mit roten Spuren! Sie hren die gewetzten Messer rotieren! Sie werden qualvoll in Stcke gerissen! Sie sind TOT!","raum10");
        raum11 = new Raum("Sie befinden sich in einem Gang, in dem Spongebob mit Patrick spielt.","raum11");
        raum12 = new Raum("Sie haben einen Ausgang gefunden! Von hier knnten sie zurck zum Schiff.","raum12");
        raum13 = new Raum("Sie befinden sich in einem Gang. Mr.Krabs bietet Ihnen einen Krabbenburger an.","raum13");
        raum14 = new Raum("Sie befinden sich in einem Gang, der durch ein Gitter mit einem Schloss versprerrt wird.","raum14");
        raum15 = new Raum("Sie haben den Schatz gefunden! Sie sind reich! Jetzt schnell raus hier!","raum15");
        raum16 = new Raum("Sie befinden sich in einer Sackgasse","raum16");
    
       
        
        // die Ausgnge initialisieren
        raum1.setzeAusgang("east", raum2);
        raum1.setzeAusgang("south", raum5);
        
        raum2.setzeAusgang("east", raum3);
        raum2.setzeAusgang("south", raum4);
        raum2.setzeAusgang("west", raum1);
        
        raum3.setzeAusgang("west", raum2);
        
        raum4.setzeAusgang("east", raum11);
        raum4.setzeAusgang("west", raum5);
        raum4.setzeAusgang("north", raum2);
        
        raum5.setzeAusgang("north", raum1);
        raum5.setzeAusgang("east", raum4);
        raum5.setzeAusgang("west", raum6);
        raum5.setzeAusgang("south", raum10);
        
        raum6.setzeAusgang("north", raum7);
        raum6.setzeAusgang("east", raum5);
        raum6.setzeAusgang("south", raum8);
        
        raum7.setzeAusgang("south", raum6);
        
        raum8.setzeAusgang("north", raum6);
        
        raum9.setzeAusgang("north", raum8);
        
        raum11.setzeAusgang("north", raum12);
        raum11.setzeAusgang("south", raum13);
        raum11.setzeAusgang("west", raum4);
        
        raum12.setzeAusgang("south", raum11);
        
        raum13.setzeAusgang("south", raum16);
        raum13.setzeAusgang("north", raum11);
        raum13.setzeAusgang("east", raum14);
        
        raum14.setzeAusgang("west", raum13);
        
        raum15.setzeAusgang("west", raum14);
        
        raum16.setzeAusgang("north", raum13);

        aktuellerRaum = raum1;  // das Spiel startet draussen
    }

    /**
     * Die Hauptmethode zum Spielen. Luft bis zum Ende des Spiels
     * in einer Schleife.
     */
    public void spielen() 
    {            
        willkommenstextAusgeben();

        // Die Hauptschleife. Hier lesen wir wiederholt Befehle ein
        // und fhren sie aus, bis das Spiel beendet wird.
                
        boolean beendet = false;
        while (! beendet) {
            Befehl befehl = parser.liefereBefehl();
            beendet = verarbeiteBefehl(befehl);
        }
        System.out.println("Ihnen geht wohl die Luft aus?! Weichei!");
    }

    /**
     * Einen Begrungstext fr den Spieler ausgeben.
     */
    private void willkommenstextAusgeben()
    {
        System.out.println();
        System.out.println("Willkommen in der Underwater World!");
        System.out.println("Underwater ist ein fantastisches Spiel in dem es viel zu entdecken gibt.");
        System.out.println("Tippen sie 'help', wenn Sie Hilfe brauchen. Wenn Sie tot sind, bitte 'quit' eingeben!");
        System.out.println("Wenn sie etwas finden und aufheben wollen, dann geben sie 'get' ein.");
        System.out.println("Wenn sie ein Gitter ffnen wollen, dann geben Sie 'open' ein.");
        System.out.println("Wenn sie etwas anznden wollen, dann geben Sie 'fire' ein.");
        System.out.println("Wenn sie etwas lsen wollen, dann geben Sie 'pull' ein.");
        System.out.println("Wenn sie den Schatz an Bord des Schiffes bringen wollen, geben Sie 'win' ein.");
        System.out.println(aktuellerRaum.gibLangeBeschreibung());
    }

    /**
     * Verarbeite einen gegebenen Befehl (fhre ihn aus).
     * Wenn der Befehl das Spiel beendet, wird 'true' zurckgeliefert,
     * andernfalls 'false'.
     */
    private boolean verarbeiteBefehl(Befehl befehl) 
    {
        boolean moechteBeenden = false;

        if(befehl.istUnbekannt()) {
            System.out.println("Ich wei nicht, was Sie meinen...");
            return false;
        }

        String befehlswort = befehl.gibBefehlswort();
        if (befehlswort.equals("help"))
            hilfstextAusgeben();
        else if (befehlswort.equals("go"))
            wechsleRaum(befehl);
        else if (befehlswort.equals("quit")) {
            moechteBeenden = beenden(befehl);
            }
        else if (befehlswort.equals("get")) 
            moechteAufheben();
        else if (befehlswort.equals("open")) 
            moechteOeffnen();
        else if (befehlswort.equals("fire")) 
            moechteAnzuenden();
        else if (befehlswort.equals("pull")) 
            moechteLoesen();
        else if (befehlswort.equals("win"))
            moechteSchatzBergen();
        return moechteBeenden;
    }

    // Implementierung der Benutzerbefehle:

    /**
     * Gib Hilfsinformationen aus.
     * Hier geben wir eine etwas alberne und unklare Beschreibung
     * aus, sowie eine Liste der Befehlswrter.
     */
    private void hilfstextAusgeben() 
    {
        System.out.println("Sie haben sich verlaufen. Sie befinden sich alleine in einem dunklen Raum mit seltsamen Geruschen..");
        System.out.println("Sie irren unterwasser herum.");
        System.out.println();
        System.out.println("Ihnen stehen folgende Befehle zur Verfgung:");
        parser.zeigeBefehle();
    }

    /**
     * Versuche, den Raum zu wechseln. Wenn es einen Ausgang gibt,
     * wechsele in den neuen Raum, ansonsten gib eine Fehlermeldung
     * aus.
     */
    private void wechsleRaum(Befehl befehl) 
    {
        if(!befehl.hatZweitesWort()) {
        	// Gibt es kein zweites Wort, wissen wir nicht, wohin...
            System.out.println("Wohin mchten Sie gehen?");
            return;
        }

        String richtung = befehl.gibZweitesWort();

        // Wir versuchen den Raum zu verlassen.
        Raum naechsterRaum = aktuellerRaum.gibAusgang(richtung);

        if (naechsterRaum == null)
            System.out.println("Dort befindet sich nur eine dunkle von Algen bedeckte schmierige Hhlenwand");
        else {
            aktuellerRaum = naechsterRaum;
            System.out.println(aktuellerRaum.gibLangeBeschreibung());
        }
    }

    /**
     * "quit" wurde eingegeben. berprfe den Rest des Befehls,
     * ob das Spiel wirklich beendet werden soll. Liefere 'true',
     * wenn der Befehl das Spiel beendet, 'false' sonst.
     */
    private boolean beenden(Befehl befehl) 
    {
        if(befehl.hatZweitesWort()) {
            System.out.println("Was soll beendet werden?");
            return false;
        }
        else
            return true;  // Das Spiel soll beendet werden.
    }
    
    private void moechteAufheben()
    {
        if (aktuellerRaum.gibName() == "raum3"){
            System.out.println("Sie ziehen die Fackeln aus der Schlacke und stecken sie in ihre Schuhe.");
            aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich in einer Sackgasse mit einem Schlackesee auf dem Boden.");
            fackelnAufgehoben = true;
        }
           else
           {
               if (aktuellerRaum.gibName() == "raum9") {
                   System.out.println("Sie heben den Schlssel auf und stecken ihn in ihre Badehose.");
                   aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich in einer Hhle.");
                   schluesselAufgehoben = true;
                   }
                   else
                   {
                       if (aktuellerRaum.gibName() == "raum15") {
                           System.out.println("Sie bergen den Schatz.Jetzt raus hier!Aber aufgepasst!");
                           aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich in einer leeren Hhle");
                           schatzGehoben = true;
                           }
                           else
                               {
                                   System.out.println("Hier gibts nichts zum Aufheben. Vollidiot!");
                               }
                    }
             }
    }
    
            
    private void moechteOeffnen()
    {
        if (aktuellerRaum.gibName() == "raum14") {
            if (schluesselAufgehoben == true){
                System.out.println("Sie stecken den Schlssel in das rostige Schloss und ffnen das Gitter unter lautem Quitschen.");
                aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich in einem Gang, an dessen Ende ein geffnetes Gitter ist.");
                raum14.setzeAusgang("east", raum15);
            }
        }
            else
            {
                System.out.println("Was willste aufschlieen, die Wand?! Trottel!");
            }
        
    }
    
    private void moechteAnzuenden()
    {
        if (aktuellerRaum.gibName() == "raum9"){
            if (fackelnAufgehoben == true){
                System.out.println("Die Hhle erhellt sich und sie knnen einen Schlssel auf dem Grund erkennen.");
                aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich in einer Hhle");
            }
        }
            else
            {
                System.out.println("Die Algen knnen doch nicht brennen! Oh Mann, ich will nen neuen Spieler");
            }
        
    }
    
    private void moechteLoesen()
    {
        if (aktuellerRaum.gibName() == "raum7"){
            System.out.println("Sie ziehen einen Stock aus dem Grund. Die Steine kommen ins Rutschen. Fliehen Sie!!");
            aktuellerRaum.setzeLangeBeschreibung("Sie befinden sich an einem Felsvorsprung, auf dem Kieselsteine liegen.");
            raum8.setzeAusgang("south", raum9);
            raum8.setzeLangeBeschreibung("Sie befinden sich in einem Gang, an dessen Ende ein zerfetztes Gitter ist.");
        }
        else 
        {
            System.out.println("Das einzige was zu hier lsen kannst, ist deine Sauerstoffflasche. Dann bin ich dich wenigstens los!");
        }
    }
    
    private void moechteSchatzBergen()
    {
        if (aktuellerRaum.gibName() == "raum12"){
            if (schatzGehoben == true) {
                System.out.println("Sie tauchen zum Schiff auf und bringen den Schatz an Bord! Endlich! Sie haben es geschafft. Der Reichtum gehrt Ihnen!");
            }
        
            else
            {
                System.out.println("Erstmal raus hier! So einfach ist das auch nicht.");
            }
        }
        else 
        {
            System.out.println("Du willst gewinnen?! Geh spielen! Bratarsch!");
        }
        
    }
}
